function [sig] = SCFDMAmod_ul(B)
ifftw = 128;
sub_c = 72;


n_samples = 2048/ifftw;


N = size(B,2);
nZer = (ifftw-size(B,1));
index = 0;

% výpočet celkové délky všech cyklických prefixů
N_CP_l_total = 0;

%
for i=0:N-1,
    l = mod(i,7); 
    if(l==0),
        N_CP_l = 160/n_samples;
    else
        N_CP_l = 144/n_samples;
    end
    N_CP_l_total = N_CP_l_total + N_CP_l;
end
sig = zeros(1, N*ifftw+N_CP_l_total);

for i = 1:N,
    % vytvoření časových vzorků signálu ze symbolů v kmitočtové oblasti
    ifft_sig = [B(37:72,i)' zeros(1,nZer) B(1:36,i)'];
    sig_without_CP = ifft(ifft_sig)*sqrt(ifftw)*sqrt(ifftw/sub_c);
    
    %vložení cyklického prefixu, vkládán je normální cylický prefix
    l = mod(i-1,7);
    if(l==0),
        N_CP_l = 160/n_samples;
    else
        N_CP_l = 144/n_samples;
    end
    % vkládání normálního cyklického prefixu
    s = sig_without_CP(end-N_CP_l+1:end);
    s2 = [s sig_without_CP];
    sig(index+1:index+ifftw+N_CP_l) = s2;
    
    % zvýšení indexu
    index = index + ifftw + N_CP_l;
end


